package aqua.backend

object Header {

  def header(isJs: Boolean, isCommonJS: Boolean): String = {
    val callParams =
      if (isJs) ""
      else
        "import type { CallParams$$ } from '@fluencelabs/fluence/dist/internal/compilerSupport/v4'"
    val imports = if (isCommonJS) {
      """const { FluencePeer } = require('@fluencelabs/fluence');
        |const {
        |    callFunction$$,
        |    registerService$$,
        |} = require('@fluencelabs/fluence/dist/internal/compilerSupport/v4${if (isJs) ".js" else ""}');""".stripMargin
    } else {
      s"""import { FluencePeer } from '@fluencelabs/fluence';
         |$callParams
         |import {
         |    callFunction$$$$,
         |    registerService$$$$,
         |} from '@fluencelabs/fluence/dist/internal/compilerSupport/v4${if (isJs) ".js"
      else ""}';""".stripMargin
    }
    s"""/**
       | *
       | * This file is auto-generated. Do not edit manually: changes may be erased.
       | * Generated by Aqua compiler: https://github.com/fluencelabs/aqua/.
       | * If you find any bugs, please write an issue on GitHub: https://github.com/fluencelabs/aqua/issues
       | * Aqua version: ${Version.version}
       | *
       | */
       |$imports
       |""".stripMargin
  }
}
